%    FOCA calulation steps (example)

% =====================================================
% step 1: load data
% =====================================================
clear all;clc
dir1 = 'data\sub_01\';
listing = dir(strcat(dir1,'*.img'));
timeN = length(listing);
DIM = [53,63,46];
DATA = zeros(DIM(1),DIM(2),DIM(3),timeN);
       
for i = 1:timeN
    filename = strcat(dir1,listing(i,1).name);
    V0 = spm_vol(filename);
    DATA(:,:,:,i) = spm_read_vols(V0); % these are functions of SPM to read .img or .nii file
end
% =================================================
% step 2: calculation
% =================================================
% brainmask    
V1 = spm_vol('data\mask1.img');    
mask = spm_read_vols(V1);
TR = 2; % Repeating Time of fMRI
ts = 2; % neiborghing times,default is equal to TR time
flag = 0; % flag = 0 -> local 27 voxels (default); flag = 1 -> local 19 voxels; flag = 2 -> local 7 voxels.

[FOCA,mFOCA,mFOCA_1,Ct,Cs] = Dong_FOCA(DATA,mask,TR,ts,flag);
% ==================================================
%  step 3: save as imges
% ==================================================
% saving
save_dir = 'results\';
% mkdir(save_dir);

savename_1 = strcat(save_dir,'Ct_sub_01.img');
savename_2 = strcat(save_dir,'Cs_sub_01.img');
savename_3 = strcat(save_dir,'FOCA_sub_01.img');
savename_4 = strcat(save_dir,'mFOCA_sub_01.img');
savename_5 = strcat(save_dir,'mFOCA-1_sub_01.img');

V0.dt = [16 0];

V0.fname = savename_1;
spm_write_vol(V0,Ct); % SPM function

V0.fname = savename_2;
spm_write_vol(V0,Cs);

V0.fname = savename_3;
spm_write_vol(V0,FOCA);

V0.fname = savename_4;
spm_write_vol(V0,mFOCA);

V0.fname = savename_5;
spm_write_vol(V0,mFOCA_1);
% =========================================================================



